;nyquist plug-in
;version 3
;type process
;name "Amiga Filter..."
;action "Applying like Amiga analog low-pass resampler..."
;info " by Eugene Sobolev aka aGGreSSor, 2013\n\nThe Amiga contains an analog low-pass filter (reconstruction filter)\nwhich is external to audio chip 'Paula'. This plug-in realized a similar effect.\n\n   n__n    ONLY AMiGA\n  (='.'=)   MAKES IT\n  ('')_('')   POSSIBLE! =)"

;Linear interpolation  , Cubic Lagrange, Cubic Splyne, Fast Sync, Precise Sync, Amiga 500, Amiga 500 (LED), Amiga 1200, Amiga 1200 (LED)

;control rolloff-choice "   Resampler " choice "Linear interpolation  , Amiga 500, Amiga 500 (LED), Amiga 1200, Amiga 1200 (LED)" 0

; quality filter value (resonance, dB)
(setf q 0.7071)

;Linear interpolation, 28867 Hz
(defun linear(s)
(biquad s 1.0 0 0 1.0 1.41421356 1.0)
(lp s (pwl 0.0 0.0 1.0 28867.0 1.0)))

; Amiga 500 - 6 dB/oct, 4900 Hz
(defun amiga500 (s) ; dummy q arg
(lp s (pwl 0.0 0.0 1.0 4900.0 1.0)))

; Amiga 500 (LED) - 12 dB/oct, 3275 Hz, Butterworth
(defun amiga500-led (s)
(if (arrayp s)
(vector (lowpass2 (aref s 0) 3275.0 q)
(lowpass2 (aref s 1) 3275.0 q))
(lowpass2 s 3275.0 q)))

; Amiga 1200 - 6 dB/oct, 28867 Hz
(defun amiga1200 (s) ; dummy q arg
(lp s (pwl 0.0 0.0 1.0 28867.0 1.0)))

; Amiga 1200 LED) - 2 x 12 dB/oct, 3275 Hz, Butterworth
(defun amiga1200-led (s)
(if (arrayp s)
(vector (lowpass4 (aref s 0) 3275.0)
(lowpass4 (aref s 1) 3275.0))
(lowpass4 s 3275.0)))

(funcall (nth rolloff-choice '(linear amiga500 amiga500-led amiga1200 amiga1200-led)) s )
